﻿; g_spot demo 03 ejn (blueznl)
;
; this program displays a simple window with some elements
; it shows zoom in/out, pan, and resize window
;
EnableExplicit
;
IncludeFile("g_spot.pb")
gs_init()
;
Global path.s
Global event.i
Global event_menu.i
Global event_gadget.i
Global refresh.i
Global action.i
;
Enumeration
  ;
  ; windows
  ;
  #w_main_nr
  ;
  ; toolbars
  ;
  #tb_main_nr
  ;
  ; gadgets
  ;
  #g_main_nr
  ;
  ; images
  ;
  #i_main_nr
  ;
  ; toolbarbuttons / functions / actions
  ;
  #f_none
  #f_panleft
  #f_panright
  #f_panup
  #f_pandown
  #f_zoomin
  #f_zoomout
  #f_zoomall
  #f_exit
  #f_handle
  #f_boundary
  #f_information
  ;
EndEnumeration
;
; one window, one toolbar, bunch of buttons
;
OpenWindow(#w_main_nr,40,40,400,400,"gspot",#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget)
CreateToolBar(#tb_main_nr,WindowID(#w_main_nr))
path.s = #PB_Compiler_FilePath+"\icons\"
ToolBarImageButton(#f_panleft,LoadImage(#f_panleft,path+"arrow_left.ico"))
ToolBarImageButton(#f_panup,LoadImage(#f_panup,path+"arrow_up.ico"))
ToolBarImageButton(#f_pandown,LoadImage(#f_pandown,path+"arrow_down.ico"))
ToolBarImageButton(#f_panright,LoadImage(#f_panright,path+"arrow_right.ico"))
ToolBarSeparator()
ToolBarImageButton(#f_zoomin,LoadImage(#f_zoomin,path+"zoomin.ico"))
ToolBarImageButton(#f_zoomout,LoadImage(#f_zoomout,path+"zoomout.ico"))
ToolBarImageButton(#f_zoomall,LoadImage(#f_zoomall,path+"earth.ico"))
ToolBarSeparator()
ToolBarImageButton(#f_handle,LoadImage(#f_handle,path+"handle.ico"))
ToolBarImageButton(#f_boundary,LoadImage(#f_boundary,path+"boundary.ico"))
ToolBarImageButton(#f_information,LoadImage(#f_information,path+"question.ico"))
ToolBarSeparator()
ToolBarImageButton(#f_exit,LoadImage(#f_exit,path+"close.ico"))

; one image one gadget, fill the whole window with the image gadget, and resize the image to match the gadget
;
ImageGadget(#g_main_nr,0,ToolBarHeight(1),10,10,0)
CreateImage(#i_main_nr,10,10)
gs_rule(0,#gs_setsize,#gs_gadget,#g_main_nr,#gs_window,#w_main_nr)
gs_rule(0,#gs_setsize,#gs_image,#i_main_nr,#gs_gadget,#g_main_nr)
;
; add some 2d objects ie elements to look at
;
gs_linexy(0,100,100,100,200,RGB($FF,0,0))
gs_circle(0,200,150,50,RGB($FF,0,0),#PB_2DDrawing_Outlined)
gs_linexy(0,200,150,300,250,RGB(0,0,$FF))
gs_linexy(0,50,250,300,250,RGB(0,0,$FF))
;
; turn on autoscale, and define the viewpane (ie. what's used for sizing the output)
; all output goes onto the iamge #i_main_nr, so we'll use that
; and lets make sure we will set the viewport so that all elements are shown
;
gs_setviewpane(0,0,#gs_image,#i_main_nr)
gs_zoomall()
gs_autoscale = #True
;
; regular event loop
;
Repeat
  event = WaitWindowEvent(50)
  event_gadget = EventGadget()
  event_menu = EventMenu()
  ;
  ; two stage event processing, first figure out what event there was
  ; if if necessary tell the next stage what action to take
  ; this makes it possible to have totally different events  to start the same action
  ;
  ; refresh is an addional flag to indicate there's a need for redrawing all elements
  ; for whatever reason
  ;
  refresh = #False
  action = #f_none
  Select event
  Case #PB_Event_CloseWindow
    action = #f_exit
  Case #PB_Event_MoveWindow, #PB_Event_SizeWindow, #PB_Event_MaximizeWindow, #PB_Event_RestoreWindow
    ;
    ; any window change should generate a call to gs_apply(), if gs_apply() detects a change
    ; that caused one of the defined rules to change an object, it will return a #true which can
    ; be used to trigger the redraw of all elements further down
    ;
    If gs_apply()
      refresh = #True
    EndIf
  Case #PB_Event_Gadget
  Case #PB_Event_Menu
    ;
    ; toolbar buttons generate menu events
    ; i'm using the same constants for menu events as for the button images as well as for the action variable
    ;
    Select event_menu
    Case #f_exit
      action = #f_exit
    Case #f_zoomall
      gs_zoomall()
      refresh = #True
    Case #f_zoomin
      gs_zoom(1.2)
      refresh = #True
    Case #f_zoomout
      gs_zoom(1/1.2)
      refresh = #True
    Case #f_panleft
      gs_pan(-0.1,0)
      refresh = #True
    Case #f_panright
      gs_pan(0.1,0)
      refresh = #True
    Case #f_panup
      gs_pan(0,-0.1)
      refresh = #True
    Case #f_pandown
      gs_pan(0,0.1)
      refresh = #True
    Case #f_handle
      gs_showhandle = 1-gs_showhandle
      refresh = #True
    Case #f_boundary
      gs_showbound = 1-gs_showbound
      refresh = #True
    Case #f_information
      If IsWindow(gs_internalsviewer_windownr)
        CloseWindow(gs_internalsviewer_windownr)
      Else
        gs_internalsviewer("")
      EndIf
    EndSelect
  EndSelect
  ;
  ; Select action
  ; EndSelect
  ;
  If refresh = #True
    If IsWindow(gs_internalsviewer_windownr)
      gs_internalsviewer("")
    EndIf
    refresh = #False
    StartDrawing(ImageOutput(#i_main_nr))
      Box(0,0,ImageWidth(#i_main_nr),ImageHeight(#i_main_nr),0)
      gs_drawallelements()
    StopDrawing()
    SetGadgetState(#g_main_nr,ImageID(#i_main_nr))
  EndIf
  ;
Until action = #f_exit
;
gs_end()

; IDE Options = PureBasic 4.51 RC 2 (Windows - x86)
; CursorPosition = 81
; FirstLine = 36
; Markers = 185
; EnableAsm
; EnableUnicode
; EnableThread
; EnableXP
; Executable = test.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 2123
; EnableBuildCount = 4
; EnableExeConstant