﻿; g_spot demo 04 ejn (blueznl)
; this program displays three different planes
;
; use the scroll wheel on your mouse to select a plane, then move the mouse to move all elements on that plane
;
EnableExplicit
IncludeFile("..\x_lib\x_lib.pb")
IncludeFile("g_spot.pb")
x_init()
gs_init()
;
Global event.i                                                                                          ; event
Global refresh.i                                                                                        ; flag to indicate a refresh is required
;
Enumeration
  ;
  ; plane numbers
  ;
  #gui
  #plane1
  #plane2
  #plane3
  #plane4
  ;
  ; gui elements
  ;
  #w_main_nr
  #g_main_nr
  #i_main_nr
  ;
EndEnumeration
;
Global x.i, y.i                                                                                         ; vars used to detect mouse movement
Global plane.i = #plane1                                                                                ; plane to shift
;
; create window, gadget, image
;
OpenWindow(#w_main_nr,10,10,800,800,"gspot",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_SizeGadget)
CreateImage(#i_main_nr,10,10)
ImageGadget(#g_main_nr,0,0,10,10,ImageID(#i_main_nr))
;
; use plane 0 for gui rules
;
gs_plane(#gui,0,0,0,0,0,"gui")
gs_rule(#gui,#gs_setsize,#gs_image,#i_main_nr,#gs_window,#w_main_nr)                                    ; resize image using window dimensions
gs_rule(#gui,#gs_setsize,#gs_gadget,#g_main_nr,#gs_window,#w_main_nr)                                   ; resize gadget using window dimensions
;
; use plane 1 for the circle
;
gs_plane(#plane1,0,0,0,0,0,"circle")
gs_circle(#plane1,0,0,400,RGB($FF,0,0),#PB_2DDrawing_Outlined)
;
; use plane 2 for the box
;
gs_plane(#plane2,0,0,0,0,0,"box")
gs_box(#plane2,-400,-400,800,800,RGB(0,0,$FF),#PB_2DDrawing_Outlined)
;
; use plane 3 for the star
;
gs_plane(#plane3,0,0,0,0,0,"star")
gs_linexy(#plane3,0,-400,400,400,RGB(0,$FF,0))
gs_linexy(#plane3,400,400,-400,-100,RGB(0,$FF,0))
gs_linexy(#plane3,-400,-100,300,-200,RGB(0,$FF,0))
gs_linexy(#plane3,300,-200,-400,400,RGB(0,$FF,0))
gs_linexy(#plane3,-400,400,0,-400,RGB(0,$FF,0))
;
; use plane 4 for a larger box that isn't shifted
;
gs_box(#plane4,-500,-500,1000,1000,RGB($80,$80,$80))
;
; set viewpane
;
gs_apply(#gui)                                                                                          ; first resize image so viewpane can match image
gs_setviewpane(0,0,#gs_image,#i_main_nr)                                                                ; set viewpane to match output image
gs_zoomall()                                                                                            ; set viewport to include all data
;
; enable shifting of elements per plane
;
gs_enableshift = #True
;
; eventloop
;
Repeat
  ;
  ; detect mouse movements and events
  ;
  If WindowMouseX(#w_main_nr) <> x Or WindowMouseY(#w_main_nr) <> y                                     ; detect mouse movement
    x = gs_windowmousex(#w_main_nr)-400
    y = gs_windowmousey(#w_main_nr)-400
    gs_shift(plane,x,y)
    refresh = #True
    event = WaitWindowEvent()                                                                           ; no delay after a move
  Else
    event = WaitWindowEvent(20)                                                                         ; delay if there was no move and no event last time
  EndIf
  ;
  ; process events
  ;
  Select event
  Case #PB_Event_MoveWindow, #PB_Event_SizeWindow, #PB_Event_MaximizeWindow, #PB_Event_RestoreWindow    ; react to all events that might need a redraw
    ;
    If gs_apply()                                                                                       ; apply rules and see if anything changed
      refresh = #True                                                                                   ; if so time to redraw
    EndIf
    ;
  Case #WM_MOUSEWHEEL                                                                                   ; check mousewheel changes to select plane
    ;
    If x_mousewheel(0) > 0
      plane = plane+1
    Else
      plane = plane-1
    EndIf
    plane = x_limit(plane,#plane1,#plane3)
    SetWindowTitle(#w_main_nr,"plane "+Str(plane))
    ;
  EndSelect
  ;
  ; redraw if required or requested
  ;
  If refresh = #True
    StartDrawing(ImageOutput(#i_main_nr))
      Box(0,0,ImageWidth(#i_main_nr),ImageHeight(#i_main_nr),0)
      gs_drawallelements()
    StopDrawing()
    SetGadgetState(#g_main_nr,ImageID(#i_main_nr))
    refresh = #False
  EndIf
  ;
Until event = #PB_Event_CloseWindow
;
x_end()
gs_end()

; IDE Options = PureBasic 4.51 RC 2 (Windows - x86)
; CursorPosition = 34
; EnableAsm
; EnableUnicode
; EnableThread
; EnableXP
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 163
; EnableBuildCount = 0
; EnableExeConstant