﻿; g_spot demo 05 ejn (blueznl)
;
; - pan (left / right / up / down / click / box / drag / image / live
; - zoom all / in / out / area
;
EnableExplicit
;
IncludeFile("..\x_lib\x_lib.pb")
IncludeFile("g_spot.pb")
gs_init()
;
Global path.s
Global event.i
Global event_menu.i
Global event_gadget.i
Global event_type.i
Global refresh.i
Global action.i
Global pan_mode.i = #gs_panclick
Global border.i
Global n.i
;
Enumeration
  ;
  ; windows
  ;
  #w_main_nr
  ;
  ; toolbars
  ;
  #tb_main_nr
  ;
  ; gadgets
  ;
  #g_main_nr
  ;
  ; images
  ;
  #i_main_nr
  ;
  ; toolbarbuttons / functions / actions
  ;
  #f_none
  #f_panleft
  #f_panright
  #f_panup
  #f_pandown
  #f_pan1_click
  #f_pan2_drag
  #f_pan3_box
  #f_pan4_image
  #f_pan5_live
  #f_zoomarea
  #f_zoomall
  #f_zoomin
  #f_zoomout
  #f_exit
  #f_handle
  #f_boundary
  #f_information
  ;
EndEnumeration
;
; one window, one toolbar, bunch of toolbar buttons
;
OpenWindow(#w_main_nr,40,40,400,400,"gspot",#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget)
CreateToolBar(#tb_main_nr,WindowID(#w_main_nr))
path.s = #PB_Compiler_FilePath+"\icons\"
;
x_toolbar_imagebutton(#tb_main_nr,#f_panleft,LoadImage(#f_panleft,path+"arrow_left.ico"),"pan left")
x_toolbar_imagebutton(#tb_main_nr,#f_panup,LoadImage(#f_panup,path+"arrow_up.ico"),"pan up")
x_toolbar_imagebutton(#tb_main_nr,#f_pandown,LoadImage(#f_pandown,path+"arrow_down.ico"),"pan down")
x_toolbar_imagebutton(#tb_main_nr,#f_panright,LoadImage(#f_panright,path+"arrow_right.ico"),"pan right")
ToolBarSeparator()
;
x_toolbar_radiobutton(#tb_main_nr,#f_pan1_click,LoadImage(#f_pan1_click,path+"1.ico"),1,"pan click")
x_toolbar_radiobutton(#tb_main_nr,#f_pan2_drag,LoadImage(#f_pan2_drag,path+"2.ico"),0,"pan drag")
x_toolbar_radiobutton(#tb_main_nr,#f_pan3_box,LoadImage(#f_pan3_box,path+"3.ico"),0,"pan box")
x_toolbar_radiobutton(#tb_main_nr,#f_pan4_image,LoadImage(#f_pan4_image,path+"4.ico"),0,"pan image")
x_toolbar_radiobutton(#tb_main_nr,#f_pan5_live,LoadImage(#f_pan5_live,path+"5.ico"),0,"pan live")
x_toolbar_radiobutton(#tb_main_nr,#f_zoomarea,LoadImage(#f_zoomarea,path+"zoom_area.ico"),0,"zoom area")
ToolBarSeparator()
;
x_toolbar_imagebutton(#tb_main_nr,#f_zoomall,LoadImage(#f_zoomall,path+"world.ico"),"view all")
x_toolbar_imagebutton(#tb_main_nr,#f_zoomin,LoadImage(#f_zoomin,path+"zoom_in.ico"),"zoom in")
x_toolbar_imagebutton(#tb_main_nr,#f_zoomout,LoadImage(#f_zoomout,path+"zoom_out.ico"),"zoom out")
ToolBarSeparator()
;
x_toolbar_togglebutton(#tb_main_nr,#f_handle,LoadImage(#f_handle,path+"handle.ico"),0,"show handles")
x_toolbar_togglebutton(#tb_main_nr,#f_boundary,LoadImage(#f_boundary,path+"boundary.ico"),0,"show bounding boxes")
x_toolbar_togglebutton(#tb_main_nr,#f_information,LoadImage(#f_information,path+"question.ico"),0,"show info")
ToolBarSeparator()
;
ToolBarImageButton(#f_exit,LoadImage(#f_exit,path+"close.ico"))
;
; create imagegadget
; create an image
; add a rule, place the gadget in the middle of the remaining space
; add a rule, size the gadget a bit smaller than the remaining space
; add a rule, size the image to match the gadget's size
;
border = 20
ImageGadget(#g_main_nr,0,ToolBarHeight(1),10,10,0)
CreateImage(#i_main_nr,10,10)
gs_rule(0,#gs_setxy,#gs_gadget,#g_main_nr,#gs_none,#gs_none,border,border+ToolBarHeight(#tb_main_nr))
gs_rule(0,#gs_setsize,#gs_gadget,#g_main_nr,#gs_window,#w_main_nr,-2*border,-2*border-ToolBarHeight(#tb_main_nr))
gs_rule(0,#gs_setsize,#gs_image,#i_main_nr,#gs_gadget,#g_main_nr)
;
; add some 2d objects ie elements to have something to look at
;
gs_linexy(0,100,100,100,200,RGB($FF,0,0))
gs_circle(0,200,150,50,RGB($FF,0,0),#PB_2DDrawing_Outlined)
gs_linexy(0,200,150,300,250,RGB(0,0,$FF))
gs_linexy(0,50,250,300,250,RGB(0,0,$FF))
gs_box(0,-50,0,450,350,RGB($80,$80,$80))
gs_box(0,90,90,20,20,RGB($FF,80,00))
;
; turn on autoscale, and define the viewpane (ie. what's used for sizing the output)
; all output goes onto the iamge #i_main_nr, so we'll use that
; and lets make sure we will set the viewport so that all elements are shown
;
gs_setviewpane(0,0,#gs_image,#i_main_nr)
gs_zoomall()
gs_autoscale = #True
;
; regular event loop
;
Repeat
  event = WaitWindowEvent(50)
  event_gadget = EventGadget()
  event_menu = EventMenu()
  event_type = EventType()
  ;
  ; two stage event processing, first figure out what event there was
  ; if necessary tell the next stage what action to take
  ; this makes it possible to have totally different events to start the same action
  ;
  ; refresh is an addional flag to indicate there's a need for redrawing all elements
  ; for whatever reason
  ;
  refresh = #False
  action = #f_none
  ;
  Select event
  Case #PB_Event_CloseWindow
    ;
    action = #f_exit
    ;
  Case #PB_Event_MoveWindow, #PB_Event_SizeWindow, #PB_Event_MaximizeWindow, #PB_Event_RestoreWindow
    ;
    ; any window change should generate a call to gs_apply(), if gs_apply() detects a change
    ; that caused one of the defined rules to change an object, it will return a #true which can
    ; be used to trigger the redraw of all elements further down
    ;
    If gs_apply()
      refresh = #True
    EndIf
    ;
  Case #PB_Event_Gadget
    ;
    Select event_gadget
    Case #g_main_nr
      ;
      ; an event took place on the main gadget ie. viewpane
      ;
      Select event_type
      Case #PB_EventType_LeftClick
        If pan_mode = 0
          gs_zoommouse(#w_main_nr,#g_main_nr,#i_main_nr)
          refresh = #True
        Else
          gs_panmouse(pan_mode,#w_main_nr,#g_main_nr,#i_main_nr)
        EndIf
        refresh = #True
      EndSelect
    EndSelect
    ;
  Case #PB_Event_Menu
    ;
    ; toolbar buttons generate menu events
    ; i'm using the same constants for menu events as for the button images as well as for the action variable
    ;
    Select event_menu
    Case #f_pan1_click
      pan_mode = #gs_panclick
    Case #f_pan2_drag
      pan_mode = #gs_pandrag
    Case #f_pan3_box
      pan_mode = #gs_panbox
    Case #f_pan4_image
      pan_mode = #gs_panimage
    Case #f_pan5_live
      pan_mode = #gs_panlive
    Case #f_zoomarea
      pan_mode = 0
    Case #f_exit
      action = #f_exit
    Case #f_zoomall
      gs_zoomall()
      refresh = #True
    Case #f_zoomin
      gs_zoom(1.4)
      refresh = #True
    Case #f_zoomout
      gs_zoom(1/1.4)
      refresh = #True
    Case #f_panleft
      gs_pan(-0.1,0)
      refresh = #True
    Case #f_panright
      gs_pan(0.1,0)
      refresh = #True
    Case #f_panup
      gs_pan(0,-0.1)
      refresh = #True
    Case #f_pandown
      gs_pan(0,0.1)
      refresh = #True
    Case #f_handle
      gs_showhandle = 1-gs_showhandle
      refresh = #True
    Case #f_boundary
      gs_showbound = 1-gs_showbound
      refresh = #True
    Case #f_information
      If IsWindow(gs_internalsviewer_windownr)
        CloseWindow(gs_internalsviewer_windownr)
      Else
        gs_internalsviewer("")
      EndIf
    EndSelect
  EndSelect
  ;
  If refresh = #True
    If IsWindow(gs_internalsviewer_windownr)
      gs_internalsviewer("")
    EndIf
    refresh = #False
    StartDrawing(ImageOutput(#i_main_nr))
      DrawingMode(#PB_2DDrawing_Default)
      FrontColor(0)
      Box(0,0,gs_viewpanewidth,gs_viewpaneheight)
      gs_drawallelements()
    StopDrawing()
    SetGadgetState(#g_main_nr,ImageID(#i_main_nr))
  EndIf
  ;
Until action = #f_exit
;
gs_end()

; IDE Options = PureBasic 4.51 RC 2 (Windows - x86)
; CursorPosition = 201
; FirstLine = 198
; Folding = -
; Markers = 109,165
; EnableAsm
; EnableUnicode
; EnableThread
; EnableXP
; Executable = test.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 2300
; EnableBuildCount = 4
; EnableExeConstant