; x_lib_test ejn (blueznl)
; testfile for x_lib
; bluez@xs4all.nl
;
; this file tests functionality and compatibility of the x_lib.pb file
; it should :-/ simplify upgrading to the next version of purebasic and help me limit bugs
; it's poorly commented, and I'm not keeping track of any versions,
; as this file should always apply to the latest version of x_lib
;
EnableExplicit
InitNetwork()
;
#x_lib_test_quick  = #True        ; set to true (1) to skip time consuming tasks
#x_lib_test_nodev  = #False       ; set to true (1) to skip all tests that rely on my specific system settings
#x_lib_test_nouser = #True        ; set to true (1) to skip all tests that require user interaction
#x_lib_test_nopure = #False       ; set to true (1) to skip purebasic issues / bugs

Procedure.q q_q(var.q)
  ProcedureReturn var.q
EndProcedure

Procedure.d d_d(var.d)
  ProcedureReturn var.d
EndProcedure

IncludeFile "x_lib.pb"
x_init()
;
x_log_set("test.log",1,1,65536,0,0,"","",1,1,0,0)
x_log_window(900,400,600,500)
x_log("start testing")
If #x_lib_test_quick = #True
  x_log("- skip slow tests")
EndIf
If #x_lib_test_nodev = #True
  x_log("- skip platform dependent tests")
EndIf
If #x_lib_test_nouser = #True
  x_log("- skip user interactive tests")
EndIf
If #x_lib_test_nopure = #True
  x_log("- skip purebasic issues/ bugs")
EndIf
;
Global a.b = 0
Global b.b = 0
Global c.d = 0
Global d.d = 0
Global d1.d, d2.d, d3.d
Global f.f = 0
Global f0.f = 0.0
Global f15.f = 1.5
Global f25.f = 2.5
Global f35.f = 3.5
Global file.s = ""
Global folder.s = ""
Global h.i = 0
Global hx.i = 0
Global h1.i = 0
Global h2.i = 0
Global h3.i = 0
Global h4.i = 0
Global h5.i = 0
Global h6.i = 0
Global h7.i = 0
Global h8.i = 0
Global h9.i = 0
Global h10.i = 0
Global h11.i = 0
Global h12.i = 0
Global i.i = 0
Global l.i = 0
Global l1.i = 0
Global l2.i = 0
Global m.i = 0
Global n.i = 0
Global nn.i = 0
Global nnn.i = 0
Global o.i = 0
Global p.i = 0
Global q.q = 0
Global qq.q = 0
Global s.s = ""
Global ss.s = ""
Global x.i = 0
Global y.i = 0
Global width.i = 0
Global height.i = 0
Global event.i = 0
Global eventmenu.i = 0
Global rect.RECT
Global d31.d = 0
Global d41.d = 0
Global d51.d = 0
Global filetime.FILETIME
Global tb_width.i = 0
;
Structure nineforty
  a.s{20}
  b.b[4]
  c.s
EndStructure
Global nineforty.nineforty
;
;
; Goto toolbar
;
; *** x_nr()
; *** x_freenr()
;
;
x_log("x_nr()")
;
x_nr()                                                                                   ; create and free a few unique numbers, freed numbers are
x_nr()                                                                                   ; handed out upon the next request after they are freed
n = x_nr()
x_freenr(n)
x_nr()
n = x_nr()
x_freenr(n)
n = x_nr()
x_nr()
x_nr()
x_freenr(n)
nn = x_nr()
;
If n = nn And nn = 4 And x_nr_n = 7
Else
  x_log("*** test 01 failed")
EndIf
;
;
; *** x_bool()
; *** x_not()
;
;
x_log("x_bool() x_not()")
;
If x_bool(1) = #False  Or x_bool(0) = #True                                              ; turn any variable in to a boolean... sort of :-)
  x_log("*** test 02 failed")
EndIf
For n = 0 To #x_intbitsize-1
  If x_bool(Pow(2,n)) = #False
    x_log("*** test 03 failed")
  EndIf
Next n
If x_not(#True) = x_Not(#False)                                                          ; x_not is actually no longer necessary, purebasic has an instruction 'not' now
  x_log("*** test 04 failed")
EndIf
If Not x_not(#True) = #False
  x_log("*** test 05 failed")
EndIf
;
;
; *** x_min()
; *** x_max()
; *** x_limit()
;
;
x_log("x_min() x_max() x_limit()")
;
If x_min(2,3) <> 2 Or x_max(2,3) <> 3 Or x_min(3,2) <> 2 Or x_max(3,2) <> 3              ; find smallest / largest of two variables
  x_log("*** test 011 failed")
EndIf
If x_limit(3,4,5) <> 4 Or x_limit(5,4,3) <> 4 Or x_limit(4,3,5) <> 4                     ; keep an integer variable between two limits
  x_log("*** test 012 failed")
EndIf
;
;
; *** x_limit_d()
; *** x_abs()
; *** x_sgn()
; *** x_sgn_d()
;
;
x_log("x_limit_d() x_abs() x_sgn() x_sgn_d()")
;
d31.d = 3.1
d41.d = 4.1
d51.d = 5.1
If x_limit_d(d31,d41,d51) <> d41 Or x_limit_d(d51,d41,d31) <> d41 Or x_limit_d(d41,d31,d51) <> d41 ; keep a double float within two limits
  x_log("*** test 021 failed")
EndIf
If x_abs(-1) <> 1 Or x_abs(2) <> 2 Or x_sgn(-1) <> -1 Or x_sgn(0) <> 0 Or x_sgn(1) <> 1            ; purebasic is still missing simple sgn and abs functions
  x_log("*** test 022 failed")
EndIf
If x_sgn_d(d31) <> 1 Or x_sgn_d(0-d31) <> -1                                                       ; do an sgn for double floats as well
  x_log("*** test 023 failed")
EndIf
;
;
; *** x_bitmask()
; *** x_binmask()
;
;
x_log("x_bitmask() binmask()")
;
For n = 0 To #x_intbitsize-1                                                                       ; bitmask sets the specified bit, check for a range of bits
  If x_bitmask(n) <> Pow(2,n)
    x_log("*** test 031 failed")
  EndIf
Next n
If x_binmask(4) <> %1111                                                                           ; binmask sets the lowest 'n' bits to 1
  x_log("*** test 032 failed")
EndIf
;
For n = 0 To #x_intbitsize-2
  i = 0
  For nn = 0 To n
    i = i + x_bitmask(nn)
  Next nn
  If x_binmask(n+1) <> i
    x_log("*** test 033 failed")
  EndIf
Next n
;
;
; *** x_rol_l()
; *** x_ror_l()
; *** x_ror_b()
; *** x_rol_b()
;
x_log("x_rol_l() x_ror_l() x_rol_b() x_ror_b()")
;
If x_rol_l(1) <> 2
  x_log("*** test 041 failed")
EndIf
i = %01001000100000100000001000001111
For n = 1 To #x_intbitsize
  i = x_rol_l(i)
Next n
If i <> %01001000100000100000001000001111
  x_log("*** test 042 failed")
EndIf
For n = 1 To #x_intbitsize
  i = x_ror_l(i)
Next n
If i <> %01001000100000100000001000001111
  x_log("*** test 043 failed")
EndIf
If x_rol_b(1) <> 2 Or x_rol_b($80) <> 1
  x_log("*** test 044 failed")
EndIf
b = 1
b = x_ror_b(b)
If x_peekb(@b) <> $80 Or x_ror_b($80) <> $40
  x_log("*** test 045 failed")
EndIf
;
;
; *** x_roln()
; *** x_rorn()
;
x_log("x_roln() x_rorn()")
;
If x_roln($101,1,8) <> $002
  x_log("*** test 051 failed")
EndIf
i = $F7F
i = x_roln(i,5,8)
i = x_roln(i,3,8)
If x_roln($F7F,8,8) <> i Or i <> $7F
  x_log("*** test 052 failed")
EndIf
;
i = $F7F
i = x_rorn(i,5,8)
i = x_rorn(i,3,8)
If x_rorn($F7F,8,8) <> $7F
  x_log("*** test 053 failed")
EndIf
i = $8F01
For n = 1 To 16
  nn = Random($FFFFFFFF)
  i = ( Random($FFFFFFFF) & $FFFF0000 ) | i
  i = x_roln(i,nn,16)
  i = ( Random($FFFFFFFF) & $FFFF0000 ) | i
  i = x_rorn(i,nn,16)
Next n
If i <> $8F01
  x_log("*** test 054 failed")
EndIf
;
;
; *** x_str()
; *** x_strex()
; *** x_val()
;
;
x_log("x_str() x_strex() x_val()")
;
If x_str(12,5) <> "00012"
  x_log("*** test 061 failed")
EndIf
If x_strex( 1234,"###") <> "***" Or x_strex( 1234,"##.##") <> "12.34" Or x_strex(-1234,"##.##") <> "*****"
  x_log("*** test 062 failed")
EndIf
If x_strex(1,".#####") <> ".00001" Or x_strex(-1,"+   .##") <> "-   .01"
  x_log("*** test 063 failed")
EndIf
;
If x_val("&H1234") <> $1234 Or x_val("$1234") <> $1234 Or x_val("0X1234") <> $1234
  x_log("*** test 064 failed")
EndIf
If x_val("&O1234") <> $29C Or x_val("&01234") <> $29C Or x_val("\1234") <> $29C
  x_log("*** test 065 failed")
EndIf
If x_val("&B10101") <> %10101 Or x_val("%10101") <> %10101
  x_log("*** test 066 failed")
EndIf
;
;
; *** x_chop()
; *** x_insert()
; *** x_rfindstring()
; *** x_propercase()
;
;
x_log("x_chop() x_insert() x_rfindstring() x_propercase()")
;
If x_chop("dit is een test",2,3) <> "t is een t"
  x_log("*** test 071 failed")
EndIf
If x_insertstring("dit is een test",8,0,"zomaar ") <> "dit is zomaar een test" Or x_insertstring("1234",3,0,"**") <> "12**34" Or x_insertstring("1234",3,1,"**") <> "12**4"
  x_log("*** test 072 failed")
EndIf
If x_rfindstring("dit is een test","is een") <> 5
  x_log("*** test 073 failed")
EndIf
If x_propercase("dit is een test") <> "Dit Is Een Test"
  x_log("*** test 074 failed")
EndIf
;
;
; *** x_parsenext()
; *** x_parsestring()
; *** x_parse()
; *** x_parsefield()
;
;
x_log("x_parse() x_parsenext() x_parsestring() x_parsefield()")
;
x_parse("dit is een test","is",0)
If x_retval <> 1 Or x_parsed <> "dit " Or x_parse <> " een test"
  x_log("*** test 081 failed")
EndIf
x_parse("dit IS een TEST","IS",#x_parse_matchcase)
If x_retval <> 1 Or x_parsed <> "dit " Or x_parse <> " een TEST"
  x_log("*** test 082 failed")
EndIf
x_parse("dit IS een TEST","is",#x_parse_matchcase)
If x_retval <> 0
  x_log("*** test 083 failed")
EndIf
x_parse("dit IS een TEST","is",#x_parse_lcase|#x_parse_anycase)
If x_retval <> 1 Or x_parsed <> "dit " Or x_parse <> " een test" Or x_parse_match <> "is"
  x_log("*** test 084 failed")
EndIf
x_parse("dit IS een TEST","XXXX",#x_parse_eol)
If x_retval <> 1
  x_log("*** test 085 failed")
EndIf
x_parse("dit is een test"," ",#x_parse_eol|#x_parse_trim)
x_parsenext()
x_parsestring(" ")
If x_retval <> 1 Or x_parsed <> "een" Or x_parse <> "test"
  x_log("*** test 086 failed")
EndIf
x_parsefield("dit is een test"," ")
If x_retval <> 4 Or x_parse_field_n <> 4 Or x_parse_field(1) <> "dit" Or x_parse_field(4) <> "test"
  x_log("*** test 087 failed")
EndIf
x_parse("abcd","b")
s.s = x_parsed
ss.s = x_parse
x_parse("abcd","bc",#x_parse_chars)
If s <> x_parsed Or ss <> x_parse
  x_log("*** test 088 failed")
EndIf
x_parse("abcd","xc",#x_parse_chars)
If x_parsed <> "ab" Or x_parse <> "d" Or x_parse_match <> "c"
  x_log("*** test 089 failed")
EndIf
If x_parse("abcd","x",0) <> x_parse("abcd","x",#x_parse_chars)
  x_log("*** test 090 failed")
EndIf
;
;
; *** x_comamndfield()
; *** x_commandcount()
;
;
x_log("x_commandfield() x_commandcount()")
;
If x_commandcount("1 2 3") <> 3
  x_log("*** test 0101 failed")
EndIf
If x_commandfield("1 2 3",2) <> "2"
  x_log("*** test 0102 failed")
EndIf
s.s = "'this is' 'a test'"
s = ReplaceString(s,"'",#DQUOTE$)
If x_commandfield(s,x_commandcount(s),#False) <> #DQUOTE$+"a test"+#DQUOTE$
  x_log("*** test 103 failed")
EndIf
;
;
; *** x_peekb()
; *** x_stringbytelength()
; *** x_pokes()
; *** x_peeks()
;
;
x_log("x_peekb() x_stringbytelength() x_pokes() x_peeks() x_pokehex() x_peekhex()")
;
b = 200
If PeekB(@b) <> -56 Or x_peekb(@b) <> 200                                                          ; regular peekb returns negative numbers, this one doesn't
  x_log("*** test 121 failed")
EndIf
;
If x_stringbytelength("dit is een test",#PB_Unicode) <> 32                                         ; more accurate (safer) than purebasic's, takes terminating zero into account
  x_log("*** test 122 failed")
EndIf
If x_stringbytelength("dit is een test",#PB_Ascii) <> 16
  x_log("*** test 123 failed")
EndIf
If x_stringbytelength("dit is een test",#PB_UTF8) <> 16
  x_log("*** test 124 failed")
EndIf
;
m = AllocateMemory(20)
PokeB(m+10,99)
If PeekB(m+10)<>99
  x_log("*** test 125 failed")
EndIf
x_pokes(m,"dit is een test",10,#PB_Ascii)                                                          ; try different modes with x_pokes() which takes care of terminating zeroes...
If PeekS(m,10,#PB_Ascii) <> "dit is een" Or PeekB(m+10)<>99
  x_log("*** test 126 failed")
EndIf
If x_peeks(m,10,#PB_Ascii) <> "dit is een"
  x_log("*** test 127 failed")
EndIf
x_pokes(m,"dit is een test",10,#PB_Unicode)
If PeekS(m,5,#PB_Unicode) <> "dit i" Or PeekB(m+10)<>99
  x_log("*** test 128 failed")
EndIf
If x_peekS(m,10,#PB_Unicode) <> "dit i"
  x_log("*** test 129 failed")
EndIf
PokeB(m+5,1)
PokeB(m+6,1)
PokeB(m+7,1)
PokeB(m+8,1)
PokeB(m+9,1)
x_pokes(m,"dit",10,#PB_Unicode)
If x_peeks(m,-1,#PB_Unicode) <> "dit" Or PeekB(m+6) <> 0 Or PeekB(m+7) <> 0 Or PeekB(m+8) <> 1 Or PeekB(m+9) <> 1
  x_log("*** test 130 failed")
EndIf
x_pokes(m,"ABC",-1,#PB_Ascii)                                                                      ; peekhex provides quick readable memory dumps
If x_peekhex(m,7) <> "$ 41 [ A ] 42 [ B ] 43 [ C ] 00 74 [ t ] 00 00"
  x_log("*** test 131 failed")
EndIf
x_pokes(m,"ABC",-1,#PB_Unicode)
If x_peekhex(m,7,0) <> "41004200430000"
  x_log("*** test 132 failed")
EndIf
;
FreeMemory(m)
;
;
; *** x_registry_get()
; *** x_registry_getx()
; *** x_registry_set()
; *** x_registry_setx()
; *** x_registry_delete()
; *** x_registry_deletex()
;
;
x_log("x_registry_get() x_registry_getx() x_registry_set() x_registry_setx() x_registry_delete() x_registry_deletex()")
;
If x_registry_get(#HKEY_CURRENT_USER,"Control Panel\Desktop","WallPaper") <> 0                                         ; is there a wallpaper set?
  x_log("*** test 151 failed")
Else
  s = x_registry_s                                                                                                     ; store it so we can restore it
  If x_registry_type <> #REG_SZ                                                                                        ; is it a string?
    x_log("*** test 152 failed")
  Else
    If x_registry_getx("#HKEY_CURRENT_USER\Control Panel\Desktop\WallPaper") <> 0                                      ; try the alternative function
      x_log("*** test 153 failed")
    Else
      If x_registry_s <> s                                                                                             ; screwed up something
        x_log("*** test 154 failed")
      Else
        If x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","WallPaper",#REG_SZ,0,"cde",0) <> 0               ; overwrite the wallpaper name
          x_log("*** test 155 failed")
        Else
          x_registry_getx("#HKEY_CURRENT_USER\Control Panel\Desktop\WallPaper")                                        ; verify if writing worked
          If x_registry_s <> "cde"
            x_log("*** test 156 failed")
          Else
            ;
            ; the registry is a nasty beast, too easy to screw up, so I encapsulated 'delete' routines deep in here, in the hope all other stuff would catch some mistakes I hope...
            ;
            If x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop\Test","Test",#REG_DWORD,1234,"",0) = 0         ; try to open a test key, should fail thus <> 0
              x_log("*** test 161 failed")
            Else
              If x_registry_setx("#HKEY_CURRENT_USER\Control Panel\Desktop\TEST\TEST",#REG_DWORD,1234,"",1) <> 0       ; try to create a test key, should succeed thus 0
                x_log("*** test 162 failed")
              Else
                x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop\Test","Test2",#REG_DWORD,5678,"",1)           ; create a second named value
                If x_registry_get(#HKEY_CURRENT_USER,"Control Panel\Desktop\Test","Test") <> 0                         ; try to get a value from an existing key
                  x_log("*** test 163 failed")
                Else
                  If x_registry_delete(#HKEY_CURRENT_USER,"Control Panel\Desktop\Test","Test") <> 0                    ; try to delete the named value 'test', should work = 0
                    x_log("*** test 164 failed")
                  Else
                    If x_registry_delete(#HKEY_CURRENT_USER,"Control Panel\Desktop\Test","Test") = 0                   ; try to delete again, should fail ie. <> 0
                      x_log("*** test 165 failed")
                    Else
                      If x_registry_deletex("#HKEY_CURRENT_USER\Control Panel\Desktop\Test\") <> 0              ; delete the whole subkey, should work
                        x_log("*** test 166 failed")
                      Else
                        If x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop\Test","Test2",#REG_DWORD,1234,"",0) = 0  ; try to open an existing named value, should fail thus <> 0
                          x_log("*** test 167 failed")
                        EndIf
                      EndIf
                    EndIf
                  EndIf
                EndIf
              EndIf
            EndIf
          EndIf
          x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","WallPaper",#REG_SZ,0,s,0)
        EndIf
      EndIf
    EndIf
  EndIf
EndIf
;
;
; *** x_exist()
; *** x_existx()
; *** x_filetimetodate()
; *** x_datetofiletime()
;
;
If #x_lib_test_quick = #False
  x_log("x_exist() x_existx() x_filetimetodate() x_datetofiletime()")
  ;
  s = "x_lib_test.tmp"
  CreateFile(1,s)
  CloseFile(1)
  If Not x_exist(s)
    x_log("*** test 181 failed")
  Else
    DeleteFile(s)
    CreateFile(1,s)
    CloseFile(1)
    x = GetFileDate(s,#PB_Date_Created)
    filetime.FILETIME
    x_datetofiletime(x,@filetime)
    If x_filetimetodate(@filetime) <> x
      x_log("*** test 182 failed")
    EndIf
    DeleteFile(s)
  EndIf
  ;
  If x_existx("A:\")                                                                               ; make sure there is no floppy in drive B:
    x_log("*** test 183 failed")
  EndIf
  If Not x_existx("C:\")                                                                           ; most systems will have a drive C: :-)
    x_log("*** test 184 failed")
  EndIf
EndIf
;
;
; *** x_matchpattern()
; *** x_matchpatternx()
;
;
x_log("x_matchpattern() x_matchpatternx()")
;
If x_matchpattern("123","123") = #False
  x_log("*** test 201 failed")
EndIf
If x_matchpattern("abc","ABC") = #False
  x_log("*** test 202 failed")
EndIf
If x_matchpattern("abc","ABC",#x_parse_anycase) = #False
  x_log("*** test 203 failed")
EndIf
If x_matchpattern("abc","ABC",#x_parse_matchcase) = #True
  x_log("*** test 204 failed")
EndIf
If x_matchpattern("abc","ABC",#x_parse_matchcase) = #True
  x_log("*** test 204 failed")
EndIf
If x_matchpattern("abcDEFghi","*DEF*",#x_parse_matchcase) = #False
  x_log("*** test 205 failed")
EndIf
If x_matchpattern("abcDEFghi","?b**cD??g*",#x_parse_matchcase) = #False
  x_log("*** test 206 failed")
EndIf
If x_matchpattern("abcDEFghi","ab|DEF|abc*gh*") = #False
  x_log("*** test 207 failed")
EndIf
;
If x_matchpatternx("123","123") = #False
  x_log("*** test 211 failed")
EndIf
If x_matchpatternx("abc","ABC",#x_parse_matchcase) = #True
  x_log("*** test 212 failed")
EndIf
If x_matchpatternx("abc","ABC",#x_parse_matchcase) = #True
  x_log("*** test 213 failed")
EndIf
If x_matchpatternx("abc","B",0,1,"") = #True
  x_log("*** test 214 failed")
EndIf
If x_matchpatternx("abc","B",1,1,"") = #False
  x_log("*** test 215 failed")
EndIf
If x_matchpatternx("abc","B",1,1,"") = #False
  x_log("*** test 216 failed")
EndIf
If x_matchpatternx("abcdef","c?e",1,1,"d") = #True                   ; result will contain a 'd' which is not acceptable
  x_log("*** test 217 failed")
EndIf
If x_matchpatternx("abcdef","c?e",1,1,"c") = #False                  ; result contains a 'c' but so does the pattern so it's ok
  x_log("*** test 218 failed")
EndIf
;
x_matchpattern("abcDEFghi","x|*cDEFg*|y",0)
If x_matchpattern_l <> 5 Or x_matchpattern_n <> 2 Or x_matchpattern_p <> 3 Or x_matchpattern_m <> "*cDEFg*" Or x_matchpattern_s <> "cDEFg"
  x_log("*** test 221 failed")
EndIf
x_matchpattern("abcDEFghi","a|*cDEFg*|y",0)
If x_matchpattern_l <> 5 Or x_matchpattern_n <> 2 Or x_matchpattern_p <> 3 Or x_matchpattern_m <> "*cDEFg*" Or x_matchpattern_s <> "cDEFg"
  x_log("*** test 222 failed")
EndIf
;
x_matchpattern("abcDEFghi","a|*bcDEFgh*",0)
If x_matchpattern_s <> "bcDEFgh"
  x_log("*** test 231 failed")
EndIf
x_matchpattern("abcDEFghi","*abcDEFghi*|b*",0)
If x_matchpattern_s <> "abcDEFghi"
  x_log("*** test 232 failed")
EndIf
x_matchpattern("abcDEFghi","?bcDEFgh?",0)
If x_matchpattern_s <> "bcDEFgh"
  x_log("*** test 233 failed")
EndIf
x_matchpattern("abcDEFghi","??cDEFg??",0)
If x_matchpattern_s <> "cDEFg"
  x_log("*** test 234 failed")
EndIf
;
;
;
; *** x_dir_simple()
; *** x_dir()
; *** x_dir_filefolder()
;
;
x_log("x_dir_simple() x_dir() x_dir_filefolder()")
;
;
s = GetCurrentDirectory()
s = s+"testfolder\"
CreateDirectory(s)
For n = 1 To 10
  For nn = 1 To 10
    CreateFile(nn,s+"file"+Str(n*10-11+nn)+"."+Chr(64+n))
    For nnn = 1 To n*10-11+nn
      WriteByte(nn,nnn)
    Next nnn
    CloseFile(nn)
    If n > 7 Or nn > 7
      s = s+"sub"+x_strex(n*10+nn-11,"##")+"\"
      CreateDirectory(s)
    EndIf
    If n > 1 And (nn = 3 Or nn = 5) Or (n = 5 And nn < 3)
      s = x_getparentpathpart(s)
    EndIf
  Next nn
Next n
;
s = GetCurrentDirectory()+"testfolder\sub07\"
x_dir_simple(s)
If x_dir_n <> 4
  x_log("*** test 301 failed")
EndIf
SelectElement(x_dir_file(),3)
If x_dir_file() <> "file8.A"
  x_log("*** test 302 failed")
EndIf
x_dir_simple(s,"*.A")
If x_dir_n <> 1
  x_log("*** test 303 failed")
EndIf
x_dir_simple(s,"*.B")
If x_dir_n <> 3
  x_log("*** test 304 failed")
EndIf
;
s = GetCurrentDirectory()+"testfolder\"
x_dir(s)
If x_dir_n <> 100
  x_log("*** test 311 failed")
EndIf
x_dir(s,"*.A")
SelectElement(x_dir_file(),5)
If x_dir_n <> 10 Or x_dir_file() <> s+"file5.A"
  x_log("*** test 312 failed")
EndIf
x_dir(s,"*.B|file2*.*")
SelectElement(x_dir_file(),5)
If x_dir_n <> 21 Or x_dir_file() <> s+"sub07\sub08\file14.B"
  x_log("*** test 313 failed")
EndIf
x_dir(s,"*.*",2,0)
SelectElement(x_dir_file(),6)
If x_dir_n <> 8 Or x_dir_file() <> s+"file6.A"
  x_log("*** test 314 failed")
EndIf
x_dir(s,"*.*",2,3)
SelectElement(x_dir_file(),7)
If x_dir_n <> 38 Or x_dir_file() <> s+"file7.A"
  x_log("*** test 315 failed")
EndIf
x_dir(s,"*.*",2,200,31)
If x_dir_n <> 31
  x_log("*** test 316 failed")
EndIf
;
s = GetCurrentDirectory()+"testfolder\"
x_dir(s,"*.*",0,3)
SelectElement(x_dir_file(),5)
If x_dir_n <> 8 Or x_dir_file() <> "file5.A"
  x_log("*** test 321 failed")
EndIf
x_dir(s,"*.*",1,3)
SelectElement(x_dir_file(),8)
If x_dir_n <> 9 Or x_dir_file() <> "sub07\"
  x_log("*** test 322 failed")
EndIf
x_dir(s,"*.*",2,3)
SelectElement(x_dir_file(),16)
If x_dir_file() <> s+"sub07\sub08\sub09\file11.B"
  x_log("*** test 323 failed")
EndIf
x_dir(s,"*.*",3,3)
SelectElement(x_dir_file(),18)
If x_dir_n <> 51 Or x_dir_file() <> s+"sub07\sub08\sub09\"
  x_log("*** test 324 failed")
EndIf
x_dir(s,"*.*",4,3)
SelectElement(x_dir_file(),0)
If x_dir_n <> 9 Or x_dir_file() <> "[sub07]"
  x_log("*** test 325 failed")
EndIf
;
s = GetCurrentDirectory()+"testfolder"
x_dir_filefolder(s)
If x_dir_n <> 76
  x_log("*** test 331 failed")
EndIf
s = GetCurrentDirectory()+"testfolder\"
x_dir_filefolder(s)
If x_dir_n <> 76
  x_log("*** test 332 failed")
EndIf
s = GetCurrentDirectory()+"testfolder\*.A"
x_dir_filefolder(s)
If x_dir_n <> 10
  x_log("*** test 333 failed")
EndIf
s = GetCurrentDirectory()+"testfolder\*.A\"
x_dir_filefolder(s)
If x_dir_n <> 0
  x_log("*** test 334 failed")
EndIf
s = GetCurrentDirectory()+"testfolder\sub*.*"
x_dir_filefolder(s)
If x_dir_n <> 0
  x_log("*** test 335 failed")
EndIf
s = GetCurrentDirectory()+"testfolder\file0.A"
x_dir_filefolder(s)
If x_dir_n <> 1
  x_log("*** test 336 failed")
EndIf
;
;
; *** x_rect_over()
; *** x_rect_overlap)
;
;
x_log("x_rect_over() x_rect_overlap()")
;
If x_rect_over(1,1,10,10,10,10) <> 0
  x_log("*** test 341 failed")
EndIf
If x_rect_over(15,15,10,10,10,10) <> 1
  x_log("*** test 342 failed")
EndIf
;
If x_rect_overlap(10,10,10,10,30,30,10,10) <> 0
  x_log("*** test 343 failed")
EndIf
If x_rect_overlap(10,10,10,10,15,15,10,10) <> 1
  x_log("*** test 344 failed")
EndIf
If x_rect_overlap(10,10,10,10,20,20,10,10) <> 1
  x_log("*** test 345 failed")
EndIf
;
;
; *** x_totaldesktops()
; *** x_window_exteriorsize()
; *** x_window_getdesktop()
; *** x_window_todesktop()
; *** x_window_supersize()
;
;
If #x_lib_test_nodev = #False
  x_log("x_totaldesktops() x_window_exteriorsize() x_window_getdesktop() x_window_todesktop() x_window_supersize()")
  ;
  x_totaldesktops()
  If x_desktops_n <> 2 Or x_desktops_x <> 0 Or x_desktops_y <> 0 Or x_desktops_width <> 3360 Or x_desktops_height <> 1050
    x_log("*** test 350 failed")
  EndIf
  ;
  ; most of these routines depend on my desktop settings and will fail on other systems...
  ; or whenever I drag the toolbar around, or change the resolution :-)
  ; yes, these are quirky :-)
  ;
  SystemParametersInfo_(#SPI_GETWORKAREA,0,@rect,0)                               ; get dimensions of workarea
  tb_width = GetSystemMetrics_(#SM_CXSCREEN)-(rect\right-rect\left+1)             ; width of the toolbar
  ;
  x = 100
  y = 200
  width = 300
  height = 400
  ;
  OpenWindow(1,x,y,width,height,"x_lib_test x_window...",#PB_Window_SystemMenu)
  If WindowX(1) <> x Or WindowY(1) <> y Or WindowWidth(1) <> width Or WindowHeight(1) <> height
    x_log("*** test 351 failed")
  EndIf
  x_window_exteriorsize(1)
  If x_retval_x <> x Or x_retval_y <> y
    x_log("*** test 352 failed")
  EndIf
  If x_retval_width <> 306 Or x_retval_height <> 425                              ; this will throw a warning if your windows settings or theme differ from mine
    x_log("... test 353 warning")
  EndIf
  x_window_getdesktop(1)                                                          ; what desktop (monitor) is the window on? shoud be the first monitor (aka desktop 0)
  If x_retval <> 0 Or x_retval_x <> WindowX(1) Or x_retval_y <> WindowY(1)
    x_log("*** test 361 failed")
  EndIf
  ;
  ResizeWindow(1,DesktopX(1)+x,#PB_Ignore,#PB_Ignore,#PB_Ignore)                  ; this moves the test window to the second monitor (aka desktop 1)
  x_window_getdesktop(1)
  If x_retval <> 1 Or WindowX(1) <> DesktopX(1)+x_retval_x Or WindowY(1) <> DesktopY(1)+x_retval_y
    x_log("*** test 362 warning")
  EndIf
  ResizeWindow(1,x_desktops_x-50,x_desktops_y-50,#PB_Ignore,#PB_Ignore)           ; this moves the test window partially out of visible desktop space on left up
  x_window_todesktop(1)
  If WindowX(1) <> tb_width Or WindowY(1) <> 0
    x_log("*** test 363 warning "+Str(WindowX(1))+" "+Str(WindowY(1)))
  EndIf
  ResizeWindow(1,x_desktops_width-50,x_desktops_height-50,#PB_Ignore,#PB_Ignore)  ; same, now on righthand bottom
  x_window_todesktop(1)
  If WindowX(1) <> 3054 Or WindowY(1) <> 597
    x_log("*** test 364 warning "+Str(WindowX(1))+" "+Str(WindowY(1)))
  EndIf
  x_window_todesktop(1,0)                                                         ; force it to another desktop / monitor
  If WindowX(1) <> 1374 Or WindowY(1) <> 597
    x_log("*** test 365 warning "+Str(WindowX(1))+" "+Str(WindowY(1)))
  EndIf
  ResizeWindow(1,x_desktops_width-50,x_desktops_height-50,1,1)                    ; off-screen and too small
  x_window_todesktop(1)
  If WindowX(1) <> 3248 Or WindowY(1) <> 947 Or WindowWidth(1) <> 106 Or WindowHeight(1) <> 50
    x_log("*** test 366 warning "+Str(WindowX(1))+" "+Str(WindowY(1))+" "+Str(WindowWidth(1))+" "+Str(WindowHeight(1)))
  EndIf
  x_window_supersize(1)                                                           ; too large for the full desktop
  If WindowX(1) <> tb_width Or WindowY(1) <> 0 Or WindowWidth(1) <> 3325 Or WindowHeight(1) <> 997
    x_log("*** test 367 warning "+Str(WindowX(1))+" "+Str(WindowY(1))+" "+Str(WindowWidth(1))+" "+Str(WindowHeight(1)))
  EndIf
  ;
  CloseWindow(1)
EndIf
;
;
; *** x_findwindow()
;
;
x_log("x_findwindow()")
;
OpenWindow(1,10,10,200,200,"x_lib_test x_findwindow()",#PB_Window_ScreenCentered|#PB_Window_SystemMenu)
If x_findwindow("*test x_find*") <> 1 Or x_window_name <> "x_lib_test x_findwindow()"
  x_log("*** test 381 failed")
EndIf
CloseWindow(1)
If x_findwindow("*test x_find*") = 1
  x_log("*** test 382 failed")
EndIf
;
;
; *** x_gadgetx()
; *** x_gadgety()
; *** x_blockgadget()
; *** x_unblockgadgets()
;
;
If #x_lib_test_nouser = #False
  ;
  x_log("x_gadgetx()( x_gadgety()) x_block_gadget() x_unblockgadgets()")
  x_log("- move the mouse and verify coordinates")
  x_log("- try to select button 2, 3, 4 and 5")
  x_log("- close the window when done")
  ;
  x = 310
  y = 320
  width = 330
  height = 340
  OpenWindow(1,100,100,400,430,"x_lib_test x_gadgetx()",#PB_Window_SystemMenu)
  PanelGadget(1,10,10,310,160)
    AddGadgetItem(1,1,"Tab 1")
    ButtonGadget(2,10,20,200,30,"Gadget 2")
    TextGadget(19,220,20,40,15,Str(GadgetX(2))+","+Str(GadgetY(2)))
    TextGadget(20,220,35,40,15,Str(x_gadgetx(2,1))+","+Str(x_gadgety(2,1)))
    ButtonGadget(3,10,60,200,30,"Gadget 3")
    TextGadget(21,220,60,40,15,Str(GadgetX(3))+","+Str(GadgetY(3)))
    TextGadget(22,220,75,40,15,Str(x_gadgetx(3,1))+","+Str(x_gadgety(3,1)))
    AddGadgetItem(1,2,"Tab 2")
  CloseGadgetList()
  ButtonGadget(4,10,190,200,30,"Gadget 4")
  TextGadget(23,220,190,40,15,Str(GadgetX(4))+","+Str(GadgetY(4)))
  TextGadget(24,220,205,40,15,Str(x_gadgetx(4,1))+","+Str(x_gadgety(4,1)))
  ButtonGadget(5,10,230,200,30,"Gadget 5")
  TextGadget(25,220,230,40,15,Str(GadgetX(5))+","+Str(GadgetY(5)))
  TextGadget(26,220,245,40,15,Str(x_gadgetx(5,1))+","+Str(x_gadgety(5,1)))
  TextGadget(28,10,285,380,15,"mouse coordinate vs. screen 0,0")
  TextGadget(29,10,300,380,15,"mouse coordinate vs. window 0,0")
  TextGadget(30,10,330,380,15,"compare mouse coordinates with button coordinates")
  TextGadget(31,10,345,380,15,"first coordinate left upper corner gadget vs. parent")
  TextGadget(32,10,360,380,15,"second coordinate left upper corder gadget vs. window")
  TextGadget(33,10,390,380,15,"gadget 2 should be disabled (purebasic, tab skips)")
  TextGadget(34,10,405,380,15,"gadget 4 should be blocked (tab works, mouseclicks don't)")
  ;
  DisableGadget(2,1)
  x_blockgadget(3,1,1)
  If x_retval <> 0
    x_log("*** test 401 failed")
  EndIf
  x_blockgadget(4,1,1)
  If x_retval <> 0
    x_log("*** test 402 failed")
  EndIf
  x_blockgadget(104,1,1)
  If x_retval <> -1
    x_log("*** test 403 failed")
  EndIf
  x_blockgadget(3,1,0)
  If x_retval <> 0
    x_log("*** test 404 failed")
  EndIf
  ;
  Repeat
    SetGadgetText(28,"mouse coordinate vs. screen "+Str(DesktopMouseX())+","+Str(DesktopMouseY()))
    SetGadgetText(29,"mouse coordinate vs. window "+Str(WindowMouseX(1))+","+Str(WindowMouseY(1)))
    event = WaitWindowEvent()
  Until event = #PB_Event_CloseWindow
  ;
  CloseWindow(1)
  x_unblockgadgets(1)
  If x_retval <> 0
    x_log("*** test 405 failed")
  EndIf
EndIf
;
;
; *** x_setrequesterposition()
; *** x_silentrequester()
;
;
If #x_lib_test_nouser = #False
  ;
  x_log("x_setrequesterposition() x_silentrequester()")
  x_log("- select 'ok' on the message requesters")
  ;
  OpenWindow(1,100,100,500,500,"x_lib_test x_setrequesterposition",#PB_Window_SystemMenu)
  x_setrequesterposition(150,150,1)
  MessageRequester("x_lib_test","this message requester as well as the next file selector"+#LF$+"should open on top of the program's window"+#LF$+"instead of screen centered as usual",#PB_MessageRequester_Ok)
  x_log("- close the file selector")
  x_setrequesterposition(150,150,1)
  OpenFileRequester("x_setrequesterposition","","*.*|All",0)
  x_log("- regular requester, should have made a sound, just close it")
  x_setrequesterposition(150,150,1)
  MessageRequester("x_lib_test","this requester makes a sound"+#LF$+"click ok to continue",#MB_ICONSTOP|#PB_MessageRequester_Ok)
  x_log("- silent requester, should have been silent, just close it")
  x_setrequesterposition(150,150,1)
  x_silentrequester(#IDI_ERROR,"x_lib_test","this requester makes no sound"+#LF$+"click ok to continue",#PB_MessageRequester_Ok,1)
  CloseWindow(1)
  ;
EndIf
;
;
; *** x_setlistviewitemtext()
; *** x_getlisticontopline()
; *** x_setlisticontopline()
; *** x_setlisticonvisibleline()
; *** x_getlisticonnextselected()
;
;
If #x_lib_test_nouser = #False
  ;
  x_log("x_getlisticontopline() x_setlisticontopline() x_setlisticonvisibleline() x_getlisticonnextselected() x_setlistviewitemtext()")
  OpenWindow(1,100,100,500,500,"x_lib_test x_getlisticontopline .. x_set_listviewitemtext()",#PB_Window_SystemMenu)
  ;
  ListIconGadget(2,10,10,480,480,"column 0",240,#PB_ListIcon_GridLines|#PB_ListIcon_MultiSelect)
  AddGadgetColumn(2,1,"column 1",240)
  For y = 0 To 100
    AddGadgetItem(2,-1,"")
    For x = 0 To 1
      SetGadgetItemText(2,y,"line "+Str(y)+" column "+Str(x),x)
    Next x
  Next y
  If x_getlisticontopline(2) <> 0
    x_log("*** test 421 failed")
  EndIf
  x_setlisticontopline(2,50)
  If x_getlisticontopline(2) <> 50
    x_log("*** test 422 failed")
  EndIf
  x_setlisticonvisibleline(2,51)
  If x_getlisticontopline(2) <> 50
    x_log("*** test 423 failed")
  EndIf
  x_setlisticonvisibleline(2,41)
  If x_getlisticontopline(2) <> 41
    x_log("*** test 424 failed")
  EndIf
  x_setlisticonvisibleline(2,90)
  If x_getlisticontopline(2) <> 60
    x_log("*** test 425 failed")
  EndIf
  ;
  x_log("- control-click items 60, 61 and 100, or close the window")
  Repeat
    n = 0
    nn = -1
    Repeat
      nn = x_getlisticonnextselected(2,nn)
      If nn = 60 Or nn = 61 Or nn = 100
        n = n+1
      EndIf
    Until nn = -1
    event = WaitWindowEvent()
  Until event = #PB_Event_CloseWindow Or n = 3
  ;
  CloseWindow(1)
  ;
EndIf
;
;
; *** x_editorgadget()
;
;
Procedure editor_gadget_callback_handler(windowid.i,message.i,wparam.i,lparam.i)
  Protected *nmhdr.NMHDR
  Protected *nmlvcustomdraw.NMLVCUSTOMDRAW
  Protected gadget_h.l, item_nr.l
  Select message
  Case #WM_NOTIFY
    *nmlvcustomdraw = lparam                              ; use to do custom drawing
    *nmhdr.NMHDR = lparam                                 ; use to grab tab key
    gadget_h = *nmhdr\hwndFrom                            ; handle of gadget that caused event
    If GetAsyncKeyState_(#VK_TAB) = 32768                 ; this is all about processing tab keys etc.
      Select gadget_h                                     ; we can process multiple gadgets upon a tab
      Case GadgetID(3)                                    ; tab was pressed on gadget number 'x'
        SetActiveGadget(4)                                ; or whatever is the next gadget
        ProcedureReturn 1                                 ; don't do anything else with this message
      EndSelect
    EndIf
  EndSelect
  ProcedureReturn #PB_ProcessPureBasicEvents              ; continue processing messages
EndProcedure
;
If #x_lib_test_nouser = #False
  ;
  x_log("x_editorgadget()")
  x_log("- text in editor wraps around")
  x_log("- use tab and shift+tab to move through all gadgets")
  OpenWindow(1,100,100,500,500,"x_editorgadget",#PB_Window_SystemMenu)
  SetWindowCallback(@editor_gadget_callback_handler(),1)
  ButtonGadget(2,10,10,70,30,"gadget 2")
  x_editorgadget(3,10,55,480,390,"","",#x_gadget_notify|#x_gadget_wordwrap)
  SetGadgetText(3,"gadget 3"+#LF$+#LF$+"text in editor wraps around"+#LF$+"use tab and shift+tab to move through all gadgets")
  ButtonGadget(4,10,457,70,30,"gadget 4")
  Repeat
    event = WaitWindowEvent()
  Until event = #PB_Event_CloseWindow
  SetWindowCallback(0,1)
  CloseWindow(1)
  ;
EndIf
;
;
toolbar:
;
; *** x_icon_createicon()
; *** x_icon_charactericon()
; *** x_toolbar_togglebutton()
; *** x_toolbar_radiobutton()
; *** x_icon_freeicon()
; *** x_button_imagetogglebutton()
; *** x_leftmousebutton()
; *** x_rightmousebutton()
; *** x_mousewheel()
;
;
x_log("x_icon_createicon() x_icon_charactericon() x_icon_freeicon()")
;
hx = x_icon_charactericon(16,16,"X",RGB(255,255,255),24)
h2 = x_icon_charactericon(16,16,"2",RGB(255,255,255),24)
h3 = x_icon_charactericon(16,16,"3",RGB(255,255,255),24)
h4 = x_icon_charactericon(16,16,"4",RGB(255,255,255),24)
h5 = x_icon_charactericon(16,16,"5",RGB(255,255,255),24)
h6 = x_icon_charactericon(16,16,"6",RGB(255,255,255),24)
h7 = x_icon_charactericon(16,16,"7",RGB(255,255,255),24)
h10 = x_icon_charactericon(16,16,"10",RGB(255,255,255),24)
h11 = x_icon_charactericon(16,16,"11",RGB(255,255,255),24)
h12 = x_icon_charactericon(16,16,"12",RGB(255,255,255),24)
;
If #x_lib_test_nouser = #False
  x_log("x_toolbar_togglebutton() x_toolbar_radiobutton() x_button_imagetogglebutton()")
  ;
  OpenWindow(1,100,100,500,500,"toolbar",#PB_Window_SystemMenu)
  CreateToolBar(2,WindowID(1))
  ;
  ToolBarStandardButton(1,#PB_ToolBarIcon_Properties)
  ToolBarImageButton(2,h2)
  ToolBarSeparator()
  ToolBarImageButton(3,h3,#PB_ToolBar_Toggle)
  SetToolBarButtonState(2,3,1)
  x_toolbar_togglebutton(2,4,h4,1,"")
  ToolBarSeparator()
  x_toolbar_radiobutton(2,5,h5,0,"")
  x_toolbar_radiobutton(2,6,h6,0,"")
  x_toolbar_radiobutton(2,7,h7,1,"")
  ;
  ButtonGadget(8,15,50,50,25,"8")
  ButtonGadget(9,75,50,50,25,"9",#PB_Button_Toggle)
  ButtonImageGadget(10,135,50,50,25,h10)
  ButtonImageGadget(11,195,50,50,25,h11,#PB_Button_Toggle)
  x_button_imagetogglebutton(12,255,50,50,25,h12,0,"")
  ;
  TextGadget(21,15,100,480,20,"toolbar button 1 pb toolbarstandardbutton push")
  TextGadget(22,15,120,480,20,"toolbar button 2 pb toolbarimagebutton push")
  TextGadget(23,15,150,480,20,"toolbar button 3 pb toolbarimagebutton toggle")
  TextGadget(24,15,170,480,20,"toolbar button 4 x_lib x_toolbartogglebutton toggle (deprecated)")
  TextGadget(25,15,200,480,20,"toolbar button 5 x_lib x_toolbar_radiobutton")
  TextGadget(26,15,220,480,20,"toolbar button 6 x_lib x_toolbar_radiobutton")
  TextGadget(27,15,240,480,20,"toolbar button 7 x_lib x_toolbar_radiobutton")
  TextGadget(28,15,270,480,20,"button 8 pb buttongadget push")
  TextGadget(29,15,290,480,20,"button 9 pb buttongadget toggle")
  TextGadget(30,15,310,480,20,"button 10 pb buttonimagegadget push")
  TextGadget(31,15,330,480,20,"button 11 pb buttonimagegadget toggle")
  TextGadget(32,15,350,480,20,"button 12 x_lib x_button_imagetogglebutton toggle (deprecated)")
  TextGadget(33,15,380,480,20,"left mouse button")
  TextGadget(34,15,400,480,20,"right mouse button")
  TextGadget(35,15,420,480,20,"last mousebutton event")
  TextGadget(36,15,450,480,20,"mousewheel");
  ;
  x_log("x_leftmousebutton() x_rightmousebutton() x_mousewheel()")
  x_log("- toggle different buttons")
  x_log("- move mouse and press mouse buttons")
  x_log("- move mouse scrollwheel")
  ;
  n = 0
  Repeat
    event = WaitWindowEvent()
    eventmenu = EventMenu()
    ;
    Select event
    Case 0
    Case #PB_Event_Menu
    Case #WM_LBUTTONUP
      SetGadgetText(35,"last event: left mouse button up")
    Case #WM_LBUTTONDOWN
      SetGadgetText(35,"last event: left mouse button down")
    Case #WM_RBUTTONUP
      SetGadgetText(35,"last event: right mouse button up")
    Case #WM_RBUTTONDOWN
      SetGadgetText(35,"last event: right mouse button down")
    Case #WM_MBUTTONUP
      SetGadgetText(35,"last event: middle mouse button up")
    Case #WM_MBUTTONDOWN
      SetGadgetText(35,"last event: middle mouse button down")
    Case #WM_MOUSEWHEEL
      n = n+x_mousewheel(0)
      SetGadgetText(36,"mousewheel: "+Str(n))
    Default
    EndSelect
    SetGadgetText(33,"left mouse button "+Str(x_leftmousebutton()))
    SetGadgetText(34,"right mouse button "+Str(x_rightmousebutton()))
    ;
  Until event = #PB_Event_CloseWindow
  CloseWindow(1)
EndIf
;
x_icon_freeicon(hx)
x_icon_freeicon(h2)
x_icon_freeicon(h3)
x_icon_freeicon(h4)
x_icon_freeicon(h5)
x_icon_freeicon(h6)
x_icon_freeicon(h7)
x_icon_freeicon(h10)
;
;
; *** x_mailslot_open()
; *** x_mailslot_close()
; *** x_mailslot_getmessage()
; *** x_mailslot_sendmessage()
;
;
x_log("x_mailslot_open() x_mailslot_close() x_mailslot_getmessage() x_mailslot_sendmessage()")
;
h1 = x_mailslot_open("channel_a")
x_mailslot_sendmessage("channel_a","1234",#PB_Ascii)
h2 = x_mailslot_open("channel_b")
x_mailslot_sendmessage("channel_b","9012",#PB_Unicode)
x_mailslot_sendmessage("channel_a","5678",#PB_Ascii)
x_mailslot_getmessage(h1,#PB_Ascii)
If x_retval_string <> "1234"
  x_log("*** test 441 failed")
EndIf
x_mailslot_getmessage(h1,#PB_Ascii)
If x_retval_string <> "5678"
  x_log("*** test 442 failed")
EndIf
x_mailslot_getmessage(h2,#PB_Unicode)
If x_retval_string <> "9012"
  x_log("*** test 443 failed")
EndIf
;
;
; *** x_createfile()
; *** x_lof()
; *** x_loc()
; *** x_fileseek()
; *** x_writebyte()
; *** x_writeword()
; *** x_writedata()
; *** x_writestring()
; *** x_writestringn()
; *** x_readbyte()
; *** x_readword()
; *** x_readlong()
; *** x_readquad()
; *** x_readstring()
;
;
x_log("x_createfile() x_log() x_log() x_fileseek() x_writebyte() x_writeword() x_writedata() x_writestring() x_writestringn()")
x_log("x_readbyte() x_readword() x_readlong() x_readquad() x_readstring()")
;
file = "d:\x_lib_test.$$$"
h = x_createfile(file,#x_file_rw)
For n = 0 To 127
  x_writebyte(h,n)
Next n
If x_lof(h) <> 128
  x_log("*** test 451 failed")
EndIf
x_fileseek(h,64)
For n = 0 To 127
  x_writebyte(h,n)
Next n
If x_lof(h) <> 192
  x_log("*** test 452 failed")
EndIf
x_fileseek(h,0)
q = 0
For n = 0 To 191
  q = q+x_readbyte(h)
Next n
If q <> 10144
  x_log("*** test 453 failed")
EndIf
x_fileseek(h,160)
If x_loc(h) <> 160
  x_log("*** test 454 failed")
EndIf
If x_readbyte(h) <> 96
  x_log("*** test 455 failed")
EndIf
If x_readword(h) <> 25185
  x_log("*** test 456 failed")
EndIf
If x_readlong(h) <> 1717920867
  x_log("*** test 457 failed")
EndIf
If x_readquad(h) <> 7957135325236127847
  x_log("*** test 458 failed")
EndIf
If x_loc(h) <> 175
  x_log("*** test 459 failed")
EndIf
;
x_fileseek(h,0)
x_writestring(h,"abcd",#PB_Unicode)
x_writeword(h,0)
x_writestring(h,"efgh",#PB_Unicode)
x_writestringn(h,"ijkl",#PB_Unicode)
x_writestring(h,"mnop",#PB_Unicode)
x_writeword(h,0)
x_fileseek(h,0)
If x_readstring(h,#PB_Unicode) <> "abcd"
  x_log("*** test 461 failed")
EndIf
If x_readstring(h,#PB_Unicode) <>"efghijkl"
  x_log("*** test 462 failed")
EndIf
If x_readstring(h,#PB_Unicode) <>"mnop"
  x_log("*** test 463 failed")
EndIf
x_fileseek(h,0)
x_writestring(h,"abcd",#PB_Ascii)
x_writebyte(h,0)
x_writestring(h,"efgh",#PB_Ascii)
x_writestringn(h,"ijkl",#PB_Ascii)
x_writestring(h,"mnop",#PB_Ascii)
x_writebyte(h,0)
x_fileseek(h,0)
If x_readstring(h,#PB_Ascii) <> "abcd"
  x_log("*** test 464 failed")
EndIf
If x_readstring(h,#PB_Ascii) <>"efghijkl"
  x_log("*** test 465 failed")
EndIf
If x_readstring(h,#PB_Ascii) <>"mnop"
  x_log("*** test 466 failed")
EndIf
;
; large file testing
;
If #x_lib_test_quick = #False
  ;
  OpenWindow(1,100,100,500,150,"file operations",#PB_Window_SystemMenu)
  TextGadget(2,10,20,480,15,"creating 5 GB file...")
  ProgressBarGadget(3,10,40,480,30,1,1000)
  TextGadget(4,10,80,480,15,"testing the file...")
  ProgressBarGadget(5,10,100,480,30,1,1000)
  x_fileseek(h,0)
  l = 1000*1000*5
  p = AllocateMemory(l)
  n = 0
  Repeat
    n = n+1
    PokeW(p,n)
    x_writedata(h,p,l)
    SetGadgetState(3,n)
    Repeat
      event = WaitWindowEvent(10)
    Until event = #PB_Event_CloseWindow Or event = 0
  Until n = 1000 Or event = #PB_Event_CloseWindow
  FreeMemory(p)
  ;
  n = 0
  Repeat
    n = n+1
    x_fileseek(h,(n-1)*l)
    SetGadgetState(5,n/1000*200)
    If x_readword(h) <> n
      x_log("*** test 471 failed")
      n = 1000
    EndIf
  Until n = 1000
  ;
  m = 0
  q = x_lof(h)
  qq = 1
  Repeat
    qq = qq+1024*256
    If qq < q
      SetGadgetState(5,200+400*qq/q)
      m = m+1
      If m > 126
        m = 0
      EndIf
      x_fileseek(h,qq)
      x_writebyte(h,m)
    EndIf
  Until qq > q
  ;
  m = 0
  qq = 1
  Repeat
    qq = qq+1024*256
    If qq < q
      SetGadgetState(5,600+400*qq/q)
      m = m+1
      If m > 126
        m = 0
      EndIf
      x_fileseek(h,qq)
      If x_readbyte(h) <> m
        x_log("*** test 472 failed")
        qq = q
      EndIf
    EndIf
  Until qq >= q
  ;
  CloseWindow(1)
EndIf
;
x_closefile(h)
DeleteFile(file)
;
;
; *** x_stringtostring()
; *** x_getdeepestpathpart()
; *** x_getparentpath()
; *** x_absolutepath()
; *** x_modifypath()
;
x_log("x_stringtostring() x_getdeepestpathpart() x_getparentpath() x_modifypath()")
;
If x_stringtostring("|dit|is|een|test",1) <> " | dit | is | een | test"                            ; see x_lib for all x_stringtostring() variations
  x_log("*** test 501 failed")
EndIf
If x_stringtostring(" dit   is    een test    ",2) <> " dit is een test "
  x_log("*** test 502 failed")
EndIf
If x_stringtostring(" dit   is    een test    ",3) <> "ditiseentest"
  x_log("*** test 503 failed")
EndIf
If x_stringtostring(" dit "+Chr(9)+"  is "+#LF$+"   een"+#CR$+" test    ",4) <> "ditiseentest"
  x_log("*** test 504 failed")
EndIf
If x_stringtostring("dit"+#CR$+"is"+#CR$+"een"+#CR$+"test",5) <> "dit | is | een | test"
  x_log("*** test 505 failed")
EndIf
If x_stringtostring("dit|is|een|test",6) <> "dit"+#CR$+"is"+#CR$+"een"+#CR$+"test"
  x_log("*** test 506 failed")
EndIf
If x_stringtostring(" dit "+Chr(9)+" is | "+#CR$+" een"+#LF$+"test",7) <> "dit  is||eentest"
  x_log("*** test 507 failed")
EndIf
If x_stringtostring(" dit "+Chr(9)+" is | "+#CR$+" een"+#LF$+"test",8) <> " dit is | eentest"
  x_log("*** test 508 failed")
EndIf
If x_stringtostring("| | dit ||is|",9) <> "dit "+#CR$+"is"+#CR$
  x_log("*** test 509 failed")
EndIf
If x_stringtostring("|dit|dit|is||een|test|dit",10) <> "dit|is|een|test"
  x_log("*** test 510 failed")
EndIf
;
If x_getdeepestpathpart("c:\abc\def\ghi") <> "ghi\"
  x_log("*** test 521 failed")
EndIf
If x_getdeepestpathpart("c:\abc\def\ghi\") <> "ghi\"
  x_log("*** test 522 failed")
EndIf
If x_getparentpathpart("c:\abc\def\ghi") <> "c:\abc\def\"
  x_log("*** test 523 failed")
EndIf
If x_getparentpathpart("c:\abc\def\ghi\") <> "c:\abc\def\"
  x_log("*** test 524 failed")
EndIf
If x_getparentpathpart("c:\") <> ""
  x_log("*** test 525 failed")
EndIf
If x_absolutepath("c:\abc\def\ghi") <> "c:\abc\def\ghi"
  x_log("*** test 526 failed")
EndIf
If x_absolutepath("c:\abc\def\ghi\") <> "c:\abc\def\ghi\"
  x_log("*** test 527 failed")
EndIf
s = GetCurrentDirectory()
s = x_getparentpathpart(s)
s = x_getparentpathpart(s)
If x_absolutepath("..\..\def\ghi") <> s+"def\ghi"
  x_log("*** test 528 failed")
EndIf
If x_absolutepath("..\..\def\ghi\") <> s+"def\ghi\"
  x_log("*** test 529 failed")
EndIf
If Mid(x_absolutepath("\def\ghi\"),4,20) <> "def\ghi\" And Left(x_absolutepath("\def\ghi\"),3) <> Left(s,3)
  x_log("*** test 530 failed")
EndIf
If x_modifypath("c:\","..\") <> "c:\"
  x_log("*** test 531 failed")
EndIf
If x_modifypath("..\..\..\test1\test2\","..\test3\test4\test5\") <> "..\..\..\test1\test3\test4\test5\"
  x_log("*** test 532 failed")
EndIf
If x_modifypath("c:\software\purebasic\_projects\codedaddy\","..\x_lib\x_lib.pb") <> "c:\software\purebasic\_projects\x_lib\x_lib.pb"
  x_log("*** test 533 failed")
EndIf
If x_modifypath("..\..\x_lib.pb","d:\test.pb") <> "d:\test.pb"
  x_log("*** test 534 failed")
EndIf
;
;
; *** x_createfolder()
;
;
x_log("x_createfolder() x_folderexist()")
;
folder = "d:\x_lib_test_folder\"
x_createdirectory(folder)
If Not x_folderexist(folder)
  x_log("*** test 541 failed")
EndIf
x_createdirectory(folder+"test1")
x_createdirectory(folder+"test2\")
x_createdirectory(folder+"test3\test4\test5")
SetCurrentDirectory(folder)
If Not (x_folderexist("test1") And x_folderexist("test2") And x_folderexist(folder+"test3\test4\test5"))
  x_log("*** test 542 failed")
EndIf
SetCurrentDirectory(x_getparentpathpart(folder))
DeleteDirectory(folder,"*.*",#PB_FileSystem_Recursive)
;
;
; *** x_gethostname()
; *** x_getipaddress()
; *** x_getmacaddress()
; *** x_ws_iptoname()
; *** x_ws_nametoip()
;
If #x_lib_test_nodev = 0
  ;
  x_log("x_gethostname() x_getipadress() x_getmacaddress()")
  s = x_gethostname()
  If LCase(s) <> LCase(Hostname())
    x_log("*** test 560 warning")
  EndIf
  If LCase(s) <> "dev2"
    x_log("*** test 561 warning")
  EndIf
  If x_getipaddress(Hostname()) <> "192.168.0.22"
    x_log("*** test 562 warning")
  EndIf
  If x_getmacaddress("192.168.0.22") <> "00:1A:A0:C8:EF:4F"
    x_log("*** test 563 warning")
  EndIf
  ;
  x_log("x_ws_start() x_ws_nametoip() x_ws_iptoname() x_ws_stop()")
  x_ws_start()
  If x_ws_nametoip("") <> "192.168.0.22"
    x_log("*** test 571 warning")
  EndIf
  If x_ws_iptoname("192.168.0.22") <> "dev2"
    x_log("*** test 572 warning")
  EndIf
  x_ws_stop()
EndIf

;
; *** purebasic bugs / issues
;
If #x_lib_test_nopure = 0
  ;
  x_log("purebasic bugs")
  a = 1
  b = 2
  If 1=1 Or a = b
  Else
    x_log("*** test 901 failed (incorrect evaluation of OR in expressions, fixed in 4.31b1)")
  EndIf
  ;
  ; type elevation
  ;
  f.f = 2/5
  m.i = 2/3+2/3+f
  If m <> 0
    x_log("*** test 902 failed (incorrect expression evaluation with mixed types)")
  EndIf
  f.f = 3
  n.i = 2/3+2/3+1/f
  If n <> 0
    x_log("*** test 903 failed (incorrect expression evaluation with mixed types)")
  EndIf
  o.i = 2/3+2/3+2/3
  If o <> 0
    x_log("*** test 904 failed (full int expression lifted type)")
  EndIf
  o.i = 2.0/3.0+2.0/3.0
  If o <> 1
    x_log("*** test 905 failed (full float expression did not lift type)")
  EndIf
  n.i = 2
  If 2/3.0 <> n.i/3.0
    x_log("*** test 906 failed (inconsistent type elevation)")
  EndIf
  ;
  ; log() pow() accuracy inconcistencies
  ;
  d.d = 0
  f.f = 0
  ;
  d.d = Log10(2.00)
  d.d = Pow(10.00,d.d)
  If Not x_near(d,2,0.000000000001)
    x_log("*** test 921 failed (inaccuracy)")
  EndIf
  d = Pow(10.00, Log10(2.00))
  If Not x_near(d,2,0.000000000001)
    x_log("*** test 922 failed (inaccuracy)")
  EndIf
  d.d = Pow(10.00, 0.3010299956639812 )
  If Not x_near(d,2,0.000000000001)
    x_log("*** test 923 failed (inaccuracy)")
  EndIf
  d.d = Pow(10.00, f.f+0.3010299956639812 )
  If Not x_near(d,2,0.000000000001)
    x_log("*** test 924 failed (inaccuracy)")
  EndIf
  d.d = Pow(10.00, f.f+0.3010299956639812 )
  If Not x_near(d,2,0.000000000001)
    x_log("*** test 925 failed (inaccuracy)")
  EndIf
  d.d = Pow(10.00, d_d(0.3010299956639812) )
  If Not x_near(d,2,0.000000000001)
    x_log("*** test 926 failed (inaccuracy)")
  EndIf
  d.d = Pow(10.00, f.f+0.3010299956 )
  If Not x_near(d,2,0.000000001)
    x_log("*** test 927 failed (inaccuracy)")
  EndIf
  d.d = 0
  d.d = Pow(10.00, d.d+0.3010299956 )
  If Not x_near(d,2,0.000000001)
    x_log("*** test 928 failed (inaccuracy)")
  EndIf
  d.d = Pow(10.00, d_d(Log10(2.00)) )
  If Not x_near(d,2,0.000000000001)
    x_log("*** test 929 failed (inaccuracy)")
  EndIf
  l1 = 1.5 + 3.5
  l2 = f15 + f25
  If l1 <> 5 Or l2 <> 4
    x_log("*** test 930 failed (rules for rounding changed")
  EndIf
  ;
  ; fixed length strings
  ;
  nineforty\a = "12345678901234567890X"
  nineforty\b[1] = 1
  nineforty\c = "12345678901234567890X"
  If nineforty\a <> PeekS(@nineforty,20) Or nineforty\a = "12345678901234567890X" Or nineforty\c <> "12345678901234567890X"
    x_log("*** test 940 warning (fixed length strings)")
  EndIf
  PokeS(@nineforty\a,"12345678901234567890")
  If nineforty\b = 1
    x_log("*** test 941 warning (fixed length strings)")
  EndIf
EndIf
;
;
x_log("done")
x_waitkeywindow(0)


; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 16
; Folding = -
; Markers = 1516
; EnableAsm
; EnableThread
; EnableXP
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 1912
; EnableBuildCount = 0
; EnableExeConstant